
/*
 * KENDALL
 * ctest.c -- test program for kendall generated parsers (includes some utility functions)
 * $Id: ctest.c 54 2005-09-11 14:42:49Z avatar $
 *
 */

#include "kendall.h"  /* struct kendall_node_t */
#include "chicken.h"

/* Constructor/destructor for kendall_node_t struct */
NODE_PTR
make_node(char *op, int label, NODE_PTR child)
{
	NODE_PTR node = malloc(sizeof(struct kendall_node_t));

	if (node != NULL) {
		node->op = malloc(strlen(op) + 1);

		if (node->op == NULL) {
			free(node);
			return(NULL);
		}

		strcpy(node->op, op);
		node->label = label;
		node->child = child;
	}

	return(node);
}

void
free_node(NODE_PTR node)
{
	free(node->op);
	free(node);
}

/* Functions defined in matcher.scm (compiled to matcher.c) */
extern void     matcher(NODE_PTR);
extern void     read_tables(void);


/* TEST PROGRAM*/

int
main(int argc, char *argv[])
{
	NODE_PTR leaf_1 = make_node("s2",    -1, NULL);
	NODE_PTR node_1 = make_node("iload", -1, leaf_1);
	NODE_PTR root_1 = make_node("iload", -1, node_1);

	NODE_PTR leaf_2 = make_node("s2",    -1, NULL);
	NODE_PTR node_2 = make_node("iload", -1, leaf_2);
	NODE_PTR root_2 = make_node("iadd",  -1, node_2);

	NODE_PTR leaf_3 = make_node("s0",     -1, NULL);
	NODE_PTR node_3 = make_node("istore", -1, leaf_3);
	NODE_PTR root_3 = make_node("istore", -1, node_3);

	NODE_PTR leaf_4 = make_node("s0",     -1, NULL);
	NODE_PTR node_4 = make_node("istore", -1, leaf_4);
	NODE_PTR root_4 = make_node("iload",  -1, node_4);

	NODE_PTR leaf_5 = make_node("s0",    -1, NULL);
	NODE_PTR node_5 = make_node("iload", -1, leaf_5);
	NODE_PTR root_5 = make_node("iload", -1, node_5);

	NODE_PTR leaf_6 = make_node("s1",   -1, NULL);
	NODE_PTR node_6 = make_node("iadd", -1, leaf_6);
	NODE_PTR root_6 = make_node("iadd", -1, node_6);

	NODE_PTR leaf_7  = make_node("s2",     -1, NULL);
	NODE_PTR node1_7 = make_node("iload",  -1, leaf_7);
	NODE_PTR node2_7 = make_node("istore", -1, node1_7);
	NODE_PTR node3_7 = make_node("iload",  -1, node2_7);
	NODE_PTR node4_7 = make_node("iadd",   -1, node3_7);
	NODE_PTR node5_7 = make_node("istore", -1, node4_7);
	NODE_PTR node6_7 = make_node("istore", -1, node5_7);
	NODE_PTR root_7  = make_node("istore", -1, node6_7);

	NODE_PTR leaf_8  = make_node("s0",     -1, NULL);
	NODE_PTR node1_8 = make_node("iload",  -1, leaf_8);
	NODE_PTR node2_8 = make_node("iload",  -1, node1_8);
	NODE_PTR node3_8 = make_node("iadd",   -1, node2_8);
	NODE_PTR root_8  = make_node("istore", -1, node3_8);

	NODE_PTR leaf_9  = make_node("s1",     -1, NULL);
	NODE_PTR node1_9 = make_node("iload",  -1, leaf_9);
	NODE_PTR node2_9 = make_node("iload",  -1, node1_9);
	NODE_PTR node3_9 = make_node("iadd",   -1, node2_9);
	NODE_PTR root_9  = make_node("istore", -1, node3_9);

	NODE_PTR leaf_0  = make_node("s2",     -1, NULL);
	NODE_PTR node1_0 = make_node("iload",  -1, leaf_0);
	NODE_PTR node2_0 = make_node("iload",  -1, node1_0);
	NODE_PTR node3_0 = make_node("iadd",   -1, node2_0);
	NODE_PTR root_0  = make_node("istore", -1, node3_0);

	NODE_PTR leaf_11  = make_node("s2",     -1, NULL);
	NODE_PTR root_11  = make_node("istore", -1, leaf_11);

	NODE_PTR leaf_12  = make_node("s2",     -1, NULL);
	NODE_PTR root_12  = make_node("iadd", -1, leaf_12);

	NODE_PTR leaf_13  = make_node("s1",     -1, NULL);
	NODE_PTR root_13  = make_node("istore", -1, leaf_13);

	NODE_PTR leaf_14  = make_node("s1",     -1, NULL);
	NODE_PTR root_14  = make_node("iload", -1, leaf_14);

	NODE_PTR leaf_15  = make_node("s2",     -1, NULL);
	NODE_PTR node_15  = make_node("istore", -1, leaf_15);
	NODE_PTR root_15  = make_node("istore", -1, node_15);

	/* CALLBACKS */
	CHICKEN_run(C_toplevel); // initialize chicken run time and eval exprs in scheme file

	/* Must be called before calling matcher() for the first time */
	read_tables();

	// TEST CASES
	fprintf(stdout, "FIRST TEST RUN\n");
	matcher(root_1); /* label(root); reduce(root) */
	fprintf(stdout, "SECOND TEST RUN\n");
	matcher(root_2);
	fprintf(stdout, "THIRD TEST RUN\n");
	matcher(root_3);
	fprintf(stdout, "FOURTH TEST RUN\n");
	matcher(root_4);
	fprintf(stdout, "FIFTH TEST RUN\n");
	matcher(root_5);
	fprintf(stdout, "SIXTH TEST RUN\n");
	matcher(root_6);
	fprintf(stdout, "SEVENTH TEST RUN\n");
	matcher(root_7);
	fprintf(stdout, "EIGHTH TEST RUN\n");
	matcher(root_8);
	fprintf(stdout, "NINTH TEST RUN\n");
	matcher(root_9);
	fprintf(stdout, "TENTH TEST RUN\n");
	matcher(root_0);
	fprintf(stdout, "ELEVENTH TEST RUN\n");
	matcher(root_11);
	fprintf(stdout, "TWELFTH TEST RUN\n");
	matcher(root_12);
	fprintf(stdout, "THIRTEENTH TEST RUN\n");
	matcher(root_13);
	fprintf(stdout, "FOURTEENTH TEST RUN\n");
	matcher(root_14);
	fprintf(stdout, "FIFTEENTH TEST RUN\n");
	matcher(root_15);

	/* DONE */
	return(0);
}

/* EOF */
